#include <bits/stdc++.h>
using namespace std;
vector<int> v[100001];
bool visited[100001]={0};
int main()
    {
        ios_base::sync_with_stdio(0);
        cin.tie(0);
        cout.tie(0);
        int N,M,A,B;
        cin >> N >> M;
        for(int i=1;i<=M;++i)
            {
                cin >> A >> B;
                v[A].push_back(B);
            }
        int temp=1;
        cout << "NO";
        return 0;
    }
